import java.rmi.*;
import java.rmi.server.*;

public class ColorClient extends javax.swing.JFrame {

    private javax.swing.JTextField colorLabel;
    private javax.swing.JButton getColor;
    private Color color;
    private ColorChecker notifyColor;

    public ColorClient() {
        initComponents();
        try {
            Remote remoteObject = Naming.lookup("COLOR");

            color = (Color) remoteObject ;
            notifyColor = new ColorChecker(colorLabel);
        }
        catch(Exception e){
            System.out.println(e);
        };

    }

    private void initComponents() {
        getColor = new javax.swing.JButton();
        colorLabel = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        getColor.setText("getColor");
        getColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
				try {
					colorLabel.setText("waiting for color...");
					color.nextColor(notifyColor);
				}
				catch(Exception e){
					System.out.println(e);
				}
            }
        });

        getContentPane().add(getColor, java.awt.BorderLayout.CENTER);

        getContentPane().add(colorLabel, java.awt.BorderLayout.SOUTH);

        pack();
    }


    public static void main(String args[]) {
                new ColorClient().setVisible(true);
    }

}

