import java.rmi.*;
import java.rmi.server.*;
import java.lang.*;
import java.util.*;
import java.util.concurrent.locks.*;
import java.rmi.registry.*;

public class Main extends UnicastRemoteObject implements Color {

    DoColor doColor;

    public Main() throws RemoteException {
    }

    public void nextColor(Notify n) throws RemoteException {
	    doColor = new DoColor(n);
	    doColor.start();
    }

    public static void main(String[] args) {
         	try {

			Main server = new Main();

			final Registry reg = LocateRegistry.createRegistry(Registry.REGISTRY_PORT);
			Naming.rebind("COLOR", server);

		}
		catch (java.net.MalformedURLException e) {
			System.out.println(e);
		}
		catch (RemoteException e) {
			System.out.println(e);
		}
    }

}

class DoColor extends Thread {
    private static String colors[]={"red","green","blue","orange","white"};
    private static int index = 0;
    private Notify notify;
    private static ReentrantLock lock=new ReentrantLock();

    public DoColor(Notify n) {
        notify = n;
    }

    public void run()  {
        try {
			lock.lock();
			int i=0;
			try {
            	index= (index + 1) % colors.length;
            	i=index;
			} finally{
				lock.unlock();
			}
            Thread.sleep(3000); // simulating a lot of CPU work
			notify.doneIt(colors[i]);
        }
        catch(Exception e){
            System.out.println(e);
        };
    }
}
